# DataFilter

> DataFilter is a special yii\base\Model for processing query filtering specification.

[API reference](/docs/api/index.md) › [yii](/docs/api/yii/index.md) › [data](/docs/api/yii/data/index.md) › DataFilter

| class | `yii\data\DataFilter` |
| --- | --- |
| Extends | [`yii\base\Model`](/docs/api/yii/base/model/index.md) » [`yii\base\Component`](/docs/api/yii/base/component/index.md) » [`yii\base\BaseObject`](/docs/api/yii/base/baseobject/index.md) |
| Implements | [`yii\base\StaticInstanceInterface`](/docs/api/yii/base/staticinstanceinterface/index.md), [`IteratorAggregate`](https://www.php.net/manual/en/class.iteratoraggregate.php), [`ArrayAccess`](https://www.php.net/manual/en/class.arrayaccess.php), [`yii\base\Arrayable`](/docs/api/yii/base/arrayable/index.md), [`yii\base\Configurable`](/docs/api/yii/base/configurable/index.md) |
| Uses traits | [`yii\base\ArrayableTrait`](/docs/api/yii/base/arrayabletrait/index.md), [`yii\base\StaticInstanceTrait`](/docs/api/yii/base/staticinstancetrait/index.md) |
| Since | 2.0.13 |
| Source | [`framework/data/DataFilter.php`](https://github.com/yiisoft/yii2/blob/22.0/framework/data/DataFilter.php#L128) |

1 subclass:

- [`ActiveDataFilter`](/docs/api/yii/data/activedatafilter/index.md)

DataFilter is a special [`Model`](/docs/api/yii/base/model/index.md) for processing query filtering specification.

It allows validating and building a filter condition passed via request.

Filter example:

```
{
    "or": [
        {
            "and": [
                {
                    "name": "some name",
                },
                {
                    "price": "25",
                }
            ]
        },
        {
            "id": {"in": [2, 5, 9]},
            "price": {
                "gt": 10,
                "lt": 50
            }
        }
    ]
}
```

In the request the filter should be specified using a key name equal to [`$filterAttributeName`](/docs/api/yii/data/datafilter/index.md#property-filterAttributeName). Thus actual HTTP request body
will look like following:

```
{
    "filter": {"or": {...}},
    "page": 2,
    ...
}
```

Raw filter value should be assigned to [`$filter`](/docs/api/yii/data/datafilter/index.md#property-filter) property of the model.
You may populate it from request data via [`load()`](/docs/api/yii/base/model/index.md#method-load) method:

```
use yii\data\DataFilter;

$dataFilter = new DataFilter();
$dataFilter->load(Yii::$app->request->getBodyParams());
```

In order to function this class requires a search model specified via [`$searchModel`](/docs/api/yii/data/datafilter/index.md#property-searchModel). This search model should declare
all available search attributes and their validation rules. For example:

```
class SearchModel extends \yii\base\Model
{
    public $id;
    public $name;

    public function rules()
    {
        return [
            [['id', 'name'], 'trim'],
            ['id', 'integer'],
            ['name', 'string'],
        ];
    }
}
```

In order to reduce amount of classes, you may use [`DynamicModel`](/docs/api/yii/base/dynamicmodel/index.md) instance as a [`$searchModel`](/docs/api/yii/data/datafilter/index.md#property-searchModel).
In this case you should specify [`$searchModel`](/docs/api/yii/data/datafilter/index.md#property-searchModel) using a PHP callable:

```
function () {
    return (new \yii\base\DynamicModel(['id' => null, 'name' => null]))
        ->addRule(['id', 'name'], 'trim')
        ->addRule('id', 'integer')
        ->addRule('name', 'string');
}
```

You can use [`validate()`](/docs/api/yii/base/model/index.md#method-validate) method to check if filter value is valid. If validation fails you can use
[`getErrors()`](/docs/api/yii/base/model/index.md#method-getErrors) to get actual error messages.

In order to acquire filter condition suitable for fetching data use [`build()`](/docs/api/yii/data/datafilter/index.md#method-build) method.

> Note: This is a base class. Its implementation of [`build()`](/docs/api/yii/data/datafilter/index.md#method-build) simply returns normalized [`$filter`](/docs/api/yii/data/datafilter/index.md#property-filter) value.
In order to convert filter to particular format you should use descendant of this class that implements
[`buildInternal()`](/docs/api/yii/data/datafilter/index.md#method-buildInternal) method accordingly.

See also: [`ActiveDataFilter`](/docs/api/yii/data/activedatafilter/index.md).

## Properties

| Property | Type | Description | Defined by |
| --- | --- | --- | --- |
| <span id="property-activeValidators"></span>[`$activeValidators`](/docs/api/yii/base/model/index.md#property-activeValidators) read-only | [`yii\validators\Validator`](/docs/api/yii/validators/validator/index.md)`[]` | The validators applicable to the current [`$scenario`](/docs/api/yii/base/model/index.md#property-scenario). | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| [`$attributeMap`](#property-attributeMap) | `array` | Actual attribute names to be used in searched condition, in format: [filterAttribute => actualAttribute]. Default: `[]`. | `DataFilter` |
| <span id="property-attributes"></span>[`$attributes`](/docs/api/yii/base/model/index.md#property-attributes) | `array<string, mixed>` | Attribute values (name => value). | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="property-behaviors"></span>[`$behaviors`](/docs/api/yii/base/component/index.md#property-behaviors) read-only | `array<`[`yii\base\Behavior`](/docs/api/yii/base/behavior/index.md)`<static>>` | List of behaviors attached to this component. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| [`$conditionValidators`](#property-conditionValidators) | `array` | Maps filter condition keywords to validation methods. Default: `['AND' => 'validateConjunctionCondition', 'OR' => 'validateConjunctionCondition', 'NOT' => 'validateBlockCondition', '<' => 'validateOperatorCondition', '>' => 'validateOperatorCondition', '<=' => 'validateOperatorCondition', '>=' => 'validateOperatorCondition', '=' => 'validateOperatorCondition', '!=' => 'validateOperatorCondition', 'IN' => 'validateOperatorCondition', 'NOT IN' => 'validateOperatorCondition', 'LIKE' => 'validateOperatorCondition']`. | `DataFilter` |
| <span id="property-errorMessages"></span>`$errorMessages` | `array\|`[`Closure`](https://www.php.net/manual/en/class.closure.php) | Error messages in `[errorKey => message]` format, or a PHP callback returning them. | `DataFilter` |
| <span id="property-errors"></span>[`$errors`](/docs/api/yii/base/model/index.md#property-errors) read-only | `array<string, string[]>` | Errors for all attributes. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="property-filter"></span>`$filter` | `mixed` | Raw filter value. | `DataFilter` |
| [`$filterAttributeLabel`](#property-filterAttributeLabel) | `string` | Label for the filter attribute specified via [`$filterAttributeName`](/docs/api/yii/data/datafilter/index.md#property-filterAttributeName). Default: `null`. | `DataFilter` |
| [`$filterAttributeName`](#property-filterAttributeName) | `string` | Name of the attribute that handles filter value. Default: `'filter'`. | `DataFilter` |
| [`$filterControls`](#property-filterControls) | `array` | Keywords or expressions that could be used in a filter. Default: `['and' => 'AND', 'or' => 'OR', 'not' => 'NOT', 'lt' => '<', 'gt' => '>', 'lte' => '<=', 'gte' => '>=', 'eq' => '=', 'neq' => '!=', 'in' => 'IN', 'nin' => 'NOT IN', 'like' => 'LIKE']`. | `DataFilter` |
| <span id="property-firstErrors"></span>[`$firstErrors`](/docs/api/yii/base/model/index.md#property-firstErrors) read-only | `array<string, string>` | The first errors. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="property-iterator"></span>[`$iterator`](/docs/api/yii/base/model/index.md#property-iterator) read-only | [`ArrayIterator`](https://www.php.net/manual/en/class.arrayiterator.php)`<string, mixed>` | An iterator for traversing the items in the list. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="property-multiValueOperators"></span>`$multiValueOperators` | `array` | List of operators keywords, which should accept multiple values. Default: `['IN', 'NOT IN']`. | `DataFilter` |
| <span id="property-nullValue"></span>`$nullValue` | `string` | Representation of `null` instead of literal `null` in case the latter cannot be used. Default: `'NULL'`. Available since 2.0.40. | `DataFilter` |
| [`$operatorTypes`](#property-operatorTypes) | `array` | Specifies the list of supported search attribute types per each operator. Default: `['<' => [self::TYPE_INTEGER, self::TYPE_FLOAT, self::TYPE_DATETIME, self::TYPE_DATE, self::TYPE_TIME], '>' => [self::TYPE_INTEGER, self::TYPE_FLOAT, self::TYPE_DATETIME, self::TYPE_DATE, self::TYPE_TIME], '<=' => [self::TYPE_INTEGER, self::TYPE_FLOAT, self::TYPE_DATETIME, self::TYPE_DATE, self::TYPE_TIME], '>=' => [self::TYPE_INTEGER, self::TYPE_FLOAT, self::TYPE_DATETIME, self::TYPE_DATE, self::TYPE_TIME], '=' => '*', '!=' => '*', 'IN' => '*', 'NOT IN' => '*', 'LIKE' => [self::TYPE_STRING]]`. | `DataFilter` |
| <span id="property-scenario"></span>[`$scenario`](/docs/api/yii/base/model/index.md#property-scenario) | `string` | The scenario that this model is in. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="property-searchAttributeTypes"></span>`$searchAttributeTypes` | `array\|null` | Search attribute type map. | `DataFilter` |
| <span id="property-searchModel"></span>`$searchModel` | [`yii\base\Model`](/docs/api/yii/base/model/index.md)`\|array\|string\|callable` | Model instance or its DI compatible configuration. | `DataFilter` |
| <span id="property-validators"></span>[`$validators`](/docs/api/yii/base/model/index.md#property-validators) read-only | [`ArrayObject`](https://www.php.net/manual/en/class.arrayobject.php)`<int,` [`yii\validators\Validator`](/docs/api/yii/validators/validator/index.md)`>\|`[`yii\validators\Validator`](/docs/api/yii/validators/validator/index.md)`[]` | All the validators declared in the model. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |

## Methods

| Method | Description | Defined by |
| --- | --- | --- |
| <span id="method-__construct"></span>[`__construct()`](/docs/api/yii/base/baseobject/index.md#method-__construct) | Constructor. | [`yii\base\BaseObject`](/docs/api/yii/base/baseobject/index.md) |
| <span id="method-__call"></span>[`__call()`](/docs/api/yii/base/component/index.md#method-__call) | Calls the named method which is not a class method. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| <span id="method-__clone"></span>[`__clone()`](/docs/api/yii/base/model/index.md#method-__clone) | This method is called after the object is created by cloning an existing one. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| [`__get()`](#method-__get) | Returns the value of a component property. | `DataFilter` |
| [`__isset()`](#method-__isset) | Checks if a property is set, i.e. defined and not null. | `DataFilter` |
| [`__set()`](#method-__set) | Sets the value of a component property. | `DataFilter` |
| [`__unset()`](#method-__unset) | Sets a component property to be null. | `DataFilter` |
| <span id="method-activeAttributes"></span>[`activeAttributes()`](/docs/api/yii/base/model/index.md#method-activeAttributes) | Returns the attribute names that are subject to validation in the current scenario. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-addError"></span>[`addError()`](/docs/api/yii/base/model/index.md#method-addError) | Adds a new error to the specified attribute. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-addErrors"></span>[`addErrors()`](/docs/api/yii/base/model/index.md#method-addErrors) | Adds a list of errors. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-afterValidate"></span>[`afterValidate()`](/docs/api/yii/base/model/index.md#method-afterValidate) | This method is invoked after validation ends. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-attachBehavior"></span>[`attachBehavior()`](/docs/api/yii/base/component/index.md#method-attachBehavior) | Attaches a behavior to this component. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| <span id="method-attachBehaviors"></span>[`attachBehaviors()`](/docs/api/yii/base/component/index.md#method-attachBehaviors) | Attaches a list of behaviors to the component. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| <span id="method-attributeHints"></span>[`attributeHints()`](/docs/api/yii/base/model/index.md#method-attributeHints) | Returns the attribute hints. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| [`attributeLabels()`](#method-attributeLabels) | Returns the attribute labels. | `DataFilter` |
| [`attributes()`](#method-attributes) | Returns the list of attribute names. | `DataFilter` |
| <span id="method-beforeValidate"></span>[`beforeValidate()`](/docs/api/yii/base/model/index.md#method-beforeValidate) | This method is invoked before validation starts. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-behaviors"></span>[`behaviors()`](/docs/api/yii/base/component/index.md#method-behaviors) | Returns a list of behaviors that this component should behave as. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| [`build()`](#method-build) | Builds actual filter specification form [`$filter`](/docs/api/yii/data/datafilter/index.md#property-filter) value. | `DataFilter` |
| [`canGetProperty()`](#method-canGetProperty) | Returns a value indicating whether a property can be read. | `DataFilter` |
| [`canSetProperty()`](#method-canSetProperty) | Returns a value indicating whether a property can be set. | `DataFilter` |
| <span id="method-className"></span>[`className()`](/docs/api/yii/base/baseobject/index.md#method-className) static | Returns the fully qualified name of this class. | [`yii\base\BaseObject`](/docs/api/yii/base/baseobject/index.md) |
| <span id="method-clearErrors"></span>[`clearErrors()`](/docs/api/yii/base/model/index.md#method-clearErrors) | Removes errors for all attributes or a single attribute. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-createValidators"></span>[`createValidators()`](/docs/api/yii/base/model/index.md#method-createValidators) | Creates validator objects based on the validation rules specified in [`rules()`](/docs/api/yii/base/model/index.md#method-rules). | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-detachBehavior"></span>[`detachBehavior()`](/docs/api/yii/base/component/index.md#method-detachBehavior) | Detaches a behavior from the component. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| <span id="method-detachBehaviors"></span>[`detachBehaviors()`](/docs/api/yii/base/component/index.md#method-detachBehaviors) | Detaches all behaviors from the component. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| <span id="method-ensureBehaviors"></span>[`ensureBehaviors()`](/docs/api/yii/base/component/index.md#method-ensureBehaviors) | Makes sure that the behaviors declared in [`behaviors()`](/docs/api/yii/base/component/index.md#method-behaviors) are attached to this component. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| <span id="method-extraFields"></span>[`extraFields()`](/docs/api/yii/base/arrayabletrait/index.md#method-extraFields) | Returns the list of fields that can be expanded further and returned by [`toArray()`](/docs/api/yii/base/arrayabletrait/index.md#method-toArray). | [`yii\base\ArrayableTrait`](/docs/api/yii/base/arrayabletrait/index.md) |
| <span id="method-fields"></span>[`fields()`](/docs/api/yii/base/model/index.md#method-fields) | Returns the list of fields that should be returned by default by [`toArray()`](/docs/api/yii/base/arrayabletrait/index.md#method-toArray) when no specific fields are specified. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| [`formName()`](#method-formName) | Returns the form name that this model class should use. | `DataFilter` |
| <span id="method-generateAttributeLabel"></span>[`generateAttributeLabel()`](/docs/api/yii/base/model/index.md#method-generateAttributeLabel) | Generates a user friendly attribute label based on the give attribute name. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-getActiveValidators"></span>[`getActiveValidators()`](/docs/api/yii/base/model/index.md#method-getActiveValidators) | Returns the validators applicable to the current [`$scenario`](/docs/api/yii/base/model/index.md#property-scenario). | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-getAttributeHint"></span>[`getAttributeHint()`](/docs/api/yii/base/model/index.md#method-getAttributeHint) | Returns the text hint for the specified attribute. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-getAttributeLabel"></span>[`getAttributeLabel()`](/docs/api/yii/base/model/index.md#method-getAttributeLabel) | Returns the text label for the specified attribute. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-getAttributes"></span>[`getAttributes()`](/docs/api/yii/base/model/index.md#method-getAttributes) | Returns attribute values. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-getBehavior"></span>[`getBehavior()`](/docs/api/yii/base/component/index.md#method-getBehavior) | Returns the named behavior object. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| <span id="method-getBehaviors"></span>[`getBehaviors()`](/docs/api/yii/base/component/index.md#method-getBehaviors) | Returns all behaviors attached to this component. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| [`getErrorMessages()`](#method-getErrorMessages) |  | `DataFilter` |
| <span id="method-getErrors"></span>[`getErrors()`](/docs/api/yii/base/model/index.md#method-getErrors) | Returns the errors for all attributes or a single attribute. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-getErrorSummary"></span>[`getErrorSummary()`](/docs/api/yii/base/model/index.md#method-getErrorSummary) | Returns the errors for all attributes as a one-dimensional array. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| [`getFilter()`](#method-getFilter) |  | `DataFilter` |
| <span id="method-getFirstError"></span>[`getFirstError()`](/docs/api/yii/base/model/index.md#method-getFirstError) | Returns the first error of the specified attribute. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-getFirstErrors"></span>[`getFirstErrors()`](/docs/api/yii/base/model/index.md#method-getFirstErrors) | Returns the first error of every attribute in the model. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-getIterator"></span>[`getIterator()`](/docs/api/yii/base/model/index.md#method-getIterator) | Returns an iterator for traversing the attributes in the model. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-getScenario"></span>[`getScenario()`](/docs/api/yii/base/model/index.md#method-getScenario) | Returns the scenario that this model is used in. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| [`getSearchAttributeTypes()`](#method-getSearchAttributeTypes) |  | `DataFilter` |
| [`getSearchModel()`](#method-getSearchModel) |  | `DataFilter` |
| <span id="method-getValidators"></span>[`getValidators()`](/docs/api/yii/base/model/index.md#method-getValidators) | Returns all the validators declared in [`rules()`](/docs/api/yii/base/model/index.md#method-rules). | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-hasErrors"></span>[`hasErrors()`](/docs/api/yii/base/model/index.md#method-hasErrors) | Returns a value indicating whether there is any validation error. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-hasEventHandlers"></span>[`hasEventHandlers()`](/docs/api/yii/base/component/index.md#method-hasEventHandlers) | Returns a value indicating whether there is any handler attached to the named event. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| <span id="method-hasMethod"></span>[`hasMethod()`](/docs/api/yii/base/component/index.md#method-hasMethod) | Returns a value indicating whether a method is defined. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| <span id="method-hasProperty"></span>[`hasProperty()`](/docs/api/yii/base/component/index.md#method-hasProperty) | Returns a value indicating whether a property is defined for this component. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| <span id="method-init"></span>[`init()`](/docs/api/yii/base/baseobject/index.md#method-init) | Initializes the object. | [`yii\base\BaseObject`](/docs/api/yii/base/baseobject/index.md) |
| <span id="method-instance"></span>[`instance()`](/docs/api/yii/base/staticinstancetrait/index.md#method-instance) static | Returns static class instance, which can be used to obtain meta information. | [`yii\base\StaticInstanceTrait`](/docs/api/yii/base/staticinstancetrait/index.md) |
| <span id="method-isAttributeActive"></span>[`isAttributeActive()`](/docs/api/yii/base/model/index.md#method-isAttributeActive) | Returns a value indicating whether the attribute is active in the current scenario. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-isAttributeRequired"></span>[`isAttributeRequired()`](/docs/api/yii/base/model/index.md#method-isAttributeRequired) | Returns a value indicating whether the attribute is required. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-isAttributeSafe"></span>[`isAttributeSafe()`](/docs/api/yii/base/model/index.md#method-isAttributeSafe) | Returns a value indicating whether the attribute is safe for massive assignments. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-load"></span>[`load()`](/docs/api/yii/base/model/index.md#method-load) | Populates the model with input data. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-loadMultiple"></span>[`loadMultiple()`](/docs/api/yii/base/model/index.md#method-loadMultiple) static | Populates a set of models with the data from end user. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| [`normalize()`](#method-normalize) | Normalizes filter value, replacing raw keys according to [`$filterControls`](/docs/api/yii/data/datafilter/index.md#property-filterControls) and [`$attributeMap`](/docs/api/yii/data/datafilter/index.md#property-attributeMap). | `DataFilter` |
| <span id="method-off"></span>[`off()`](/docs/api/yii/base/component/index.md#method-off) | Detaches an existing event handler from this component. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| <span id="method-offsetExists"></span>[`offsetExists()`](/docs/api/yii/base/model/index.md#method-offsetExists) | Returns whether there is an element at the specified offset. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-offsetGet"></span>[`offsetGet()`](/docs/api/yii/base/model/index.md#method-offsetGet) | Returns the element at the specified offset. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-offsetSet"></span>[`offsetSet()`](/docs/api/yii/base/model/index.md#method-offsetSet) | Sets the element at the specified offset. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-offsetUnset"></span>[`offsetUnset()`](/docs/api/yii/base/model/index.md#method-offsetUnset) | Sets the element value at the specified offset to null. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-on"></span>[`on()`](/docs/api/yii/base/component/index.md#method-on) | Attaches an event handler to an event. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| <span id="method-onUnsafeAttribute"></span>[`onUnsafeAttribute()`](/docs/api/yii/base/model/index.md#method-onUnsafeAttribute) | This method is invoked when an unsafe attribute is being massively assigned. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| [`rules()`](#method-rules) | Returns the validation rules for attributes. | `DataFilter` |
| <span id="method-safeAttributes"></span>[`safeAttributes()`](/docs/api/yii/base/model/index.md#method-safeAttributes) | Returns the attribute names that are safe to be massively assigned in the current scenario. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-scenarios"></span>[`scenarios()`](/docs/api/yii/base/model/index.md#method-scenarios) | Returns a list of scenarios and the corresponding active attributes. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="method-setAttributes"></span>[`setAttributes()`](/docs/api/yii/base/model/index.md#method-setAttributes) | Sets the attribute values in a massive way. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| [`setErrorMessages()`](#method-setErrorMessages) | Sets the list of error messages responding to invalid filter structure, in format: `[errorKey => message]`. | `DataFilter` |
| [`setFilter()`](#method-setFilter) |  | `DataFilter` |
| <span id="method-setScenario"></span>[`setScenario()`](/docs/api/yii/base/model/index.md#method-setScenario) | Sets the scenario for the model. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| [`setSearchAttributeTypes()`](#method-setSearchAttributeTypes) |  | `DataFilter` |
| [`setSearchModel()`](#method-setSearchModel) |  | `DataFilter` |
| <span id="method-toArray"></span>[`toArray()`](/docs/api/yii/base/arrayabletrait/index.md#method-toArray) | Converts the model into an array. | [`yii\base\ArrayableTrait`](/docs/api/yii/base/arrayabletrait/index.md) |
| <span id="method-trigger"></span>[`trigger()`](/docs/api/yii/base/component/index.md#method-trigger) | Triggers an event. | [`yii\base\Component`](/docs/api/yii/base/component/index.md) |
| <span id="method-validate"></span>[`validate()`](/docs/api/yii/base/model/index.md#method-validate) | Performs the data validation. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| [`validateFilter()`](#method-validateFilter) | Validates filter attribute value to match filer condition specification. | `DataFilter` |
| <span id="method-validateMultiple"></span>[`validateMultiple()`](/docs/api/yii/base/model/index.md#method-validateMultiple) static | Validates multiple models. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| [`buildInternal()`](#method-buildInternal) protected | Performs actual filter build. | `DataFilter` |
| [`defaultErrorMessages()`](#method-defaultErrorMessages) protected | Returns default values for [`$errorMessages`](/docs/api/yii/data/datafilter/index.md#property-errorMessages). | `DataFilter` |
| [`detectSearchAttributeType()`](#method-detectSearchAttributeType) protected | Detect attribute type from given validator. | `DataFilter` |
| [`detectSearchAttributeTypes()`](#method-detectSearchAttributeTypes) protected | Composes default value for [`$searchAttributeTypes`](/docs/api/yii/data/datafilter/index.md#property-searchAttributeTypes) from the [`$searchModel`](/docs/api/yii/data/datafilter/index.md#property-searchModel) validation rules. | `DataFilter` |
| <span id="method-extractFieldsFor"></span>[`extractFieldsFor()`](/docs/api/yii/base/arrayabletrait/index.md#method-extractFieldsFor) protected | Extract nested fields from a fields collection for a given root field Nested fields are separated with dots (.). e.g: "item.id" The previous example would extract "id". | [`yii\base\ArrayableTrait`](/docs/api/yii/base/arrayabletrait/index.md) |
| <span id="method-extractRootFields"></span>[`extractRootFields()`](/docs/api/yii/base/arrayabletrait/index.md#method-extractRootFields) protected | Extracts the root field names from nested fields. | [`yii\base\ArrayableTrait`](/docs/api/yii/base/arrayabletrait/index.md) |
| [`filterAttributeValue()`](#method-filterAttributeValue) protected | Validates attribute value in the scope of [`$searchModel`](/docs/api/yii/data/datafilter/index.md#property-searchModel), applying attribute value filters if any. | `DataFilter` |
| [`parseErrorMessage()`](#method-parseErrorMessage) protected | Parses content of the message from [`$errorMessages`](/docs/api/yii/data/datafilter/index.md#property-errorMessages), specified by message key. | `DataFilter` |
| <span id="method-resolveFields"></span>[`resolveFields()`](/docs/api/yii/base/arrayabletrait/index.md#method-resolveFields) protected | Determines which fields can be returned by [`toArray()`](/docs/api/yii/base/arrayabletrait/index.md#method-toArray). | [`yii\base\ArrayableTrait`](/docs/api/yii/base/arrayabletrait/index.md) |
| [`validateAttributeCondition()`](#method-validateAttributeCondition) protected | Validates search condition for a particular attribute. | `DataFilter` |
| [`validateAttributeValue()`](#method-validateAttributeValue) protected | Validates attribute value in the scope of [`Model`](/docs/api/yii/base/model/index.md). | `DataFilter` |
| [`validateBlockCondition()`](#method-validateBlockCondition) protected | Validates block condition that consists of a single condition. | `DataFilter` |
| [`validateCondition()`](#method-validateCondition) protected | Validates filter condition. | `DataFilter` |
| [`validateConjunctionCondition()`](#method-validateConjunctionCondition) protected | Validates conjunction condition that consists of multiple independent ones. | `DataFilter` |
| [`validateOperatorCondition()`](#method-validateOperatorCondition) protected | Validates operator condition. | `DataFilter` |

## Events

| Event | Type | Description | Defined by |
| --- | --- | --- | --- |
| <span id="event-EVENT_BEFORE_VALIDATE"></span>[`EVENT_BEFORE_VALIDATE`](/docs/api/yii/base/model/index.md#event-EVENT_BEFORE_VALIDATE) | [`yii\base\ModelEvent`](/docs/api/yii/base/modelevent/index.md) | An event raised at the beginning of [`validate()`](/docs/api/yii/base/model/index.md#method-validate). Event name: `'beforeValidate'`. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |
| <span id="event-EVENT_AFTER_VALIDATE"></span>[`EVENT_AFTER_VALIDATE`](/docs/api/yii/base/model/index.md#event-EVENT_AFTER_VALIDATE) | [`yii\base\Event`](/docs/api/yii/base/event/index.md) | An event raised at the end of [`validate()`](/docs/api/yii/base/model/index.md#method-validate) Event name: `'afterValidate'`. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |

## Constants

| Constant | Value | Description | Defined by |
| --- | --- | --- | --- |
| <span id="const-TYPE_INTEGER"></span>`TYPE_INTEGER` | `'integer'` |  | `DataFilter` |
| <span id="const-TYPE_FLOAT"></span>`TYPE_FLOAT` | `'float'` |  | `DataFilter` |
| <span id="const-TYPE_BOOLEAN"></span>`TYPE_BOOLEAN` | `'boolean'` |  | `DataFilter` |
| <span id="const-TYPE_STRING"></span>`TYPE_STRING` | `'string'` |  | `DataFilter` |
| <span id="const-TYPE_ARRAY"></span>`TYPE_ARRAY` | `'array'` |  | `DataFilter` |
| <span id="const-TYPE_DATETIME"></span>`TYPE_DATETIME` | `'datetime'` |  | `DataFilter` |
| <span id="const-TYPE_DATE"></span>`TYPE_DATE` | `'date'` |  | `DataFilter` |
| <span id="const-TYPE_TIME"></span>`TYPE_TIME` | `'time'` |  | `DataFilter` |
| <span id="const-SCENARIO_DEFAULT"></span>[`SCENARIO_DEFAULT`](/docs/api/yii/base/model/index.md#const-SCENARIO_DEFAULT) | `'default'` | The name of the default scenario. | [`yii\base\Model`](/docs/api/yii/base/model/index.md) |

## Property details

### $attributeMap <span id="property-attributeMap"></span>

```php
public array $attributeMap = []
```

Actual attribute names to be used in searched condition, in format: [filterAttribute => actualAttribute].

For example, in case of using table joins in the search query, attribute map may look like the following:

```
[
    'authorName' => '{{author}}.[[name]]'
]
```

Attribute map will be applied to filter condition in [`normalize()`](/docs/api/yii/data/datafilter/index.md#method-normalize) method.

### $conditionValidators <span id="property-conditionValidators"></span>

```php
public array $conditionValidators = ['AND' => 'validateConjunctionCondition', 'OR' => 'validateConjunctionCondition', 'NOT' => 'validateBlockCondition', '<' => 'validateOperatorCondition', '>' => 'validateOperatorCondition', '<=' => 'validateOperatorCondition', '>=' => 'validateOperatorCondition', '=' => 'validateOperatorCondition', '!=' => 'validateOperatorCondition', 'IN' => 'validateOperatorCondition', 'NOT IN' => 'validateOperatorCondition', 'LIKE' => 'validateOperatorCondition']
```

Maps filter condition keywords to validation methods.

These methods are used by [`validateCondition()`](/docs/api/yii/data/datafilter/index.md#method-validateCondition) to validate raw filter conditions.

### $filterAttributeLabel <span id="property-filterAttributeLabel"></span>

```php
public string $filterAttributeLabel = null
```

Label for the filter attribute specified via [`$filterAttributeName`](/docs/api/yii/data/datafilter/index.md#property-filterAttributeName).

It will be used during error messages composition.

### $filterAttributeName <span id="property-filterAttributeName"></span>

```php
public string $filterAttributeName = 'filter'
```

Name of the attribute that handles filter value.

The name is used to load data via [`load()`](/docs/api/yii/base/model/index.md#method-load) method.

### $filterControls <span id="property-filterControls"></span>

```php
public array $filterControls = ['and' => 'AND', 'or' => 'OR', 'not' => 'NOT', 'lt' => '<', 'gt' => '>', 'lte' => '<=', 'gte' => '>=', 'eq' => '=', 'neq' => '!=', 'in' => 'IN', 'nin' => 'NOT IN', 'like' => 'LIKE']
```

Keywords or expressions that could be used in a filter.

Array keys are the expressions used in raw filter value obtained from user request.
Array values are internal build keys used in this class methods.

Any unspecified keyword will not be recognized as a filter control and will be treated as
an attribute name. Thus you should avoid conflicts between control keywords and attribute names.
For example: in case you have control keyword 'like' and an attribute named 'like', specifying condition
for such attribute will be impossible.

You may specify several keywords for the same filter build key, creating multiple aliases. For example:

```
[
    'eq' => '=',
    '=' => '=',
    '==' => '=',
    '===' => '=',
    // ...
]
```

> Note: while specifying filter controls take actual data exchange format, which your API uses, in mind.
> Make sure each specified control keyword is valid for the format. For example, in XML tag name can start
> only with a letter character, thus controls like `>`, '=' or `$gt` will break the XML schema.

### $operatorTypes <span id="property-operatorTypes"></span>

```php
public array $operatorTypes = ['<' => [self::TYPE_INTEGER, self::TYPE_FLOAT, self::TYPE_DATETIME, self::TYPE_DATE, self::TYPE_TIME], '>' => [self::TYPE_INTEGER, self::TYPE_FLOAT, self::TYPE_DATETIME, self::TYPE_DATE, self::TYPE_TIME], '<=' => [self::TYPE_INTEGER, self::TYPE_FLOAT, self::TYPE_DATETIME, self::TYPE_DATE, self::TYPE_TIME], '>=' => [self::TYPE_INTEGER, self::TYPE_FLOAT, self::TYPE_DATETIME, self::TYPE_DATE, self::TYPE_TIME], '=' => '*', '!=' => '*', 'IN' => '*', 'NOT IN' => '*', 'LIKE' => [self::TYPE_STRING]]
```

Specifies the list of supported search attribute types per each operator.

This field should be in format: 'operatorKeyword' => ['type1', 'type2' ...].
Supported types list can be specified as `*`, which indicates that operator supports all types available.
Any unspecified keyword will not be considered as a valid operator.

## Method details

### __get() <span id="method-__get"></span>

```php
public function __get(mixed $name): mixed
```

Returns the value of a component property.

This method will check in the following order and act accordingly:

 - a property defined by a getter: return the getter result
 - a property of a behavior: return the behavior property value

Do not call this method directly as it is a PHP magic method that
will be implicitly called when executing `$value = $component->property;`.

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$name` | `mixed` | The property name |

**Returns**

`mixed`: The property value or the value of a behavior's property

**Throws**

- [`yii\base\UnknownPropertyException`](/docs/api/yii/base/unknownpropertyexception/index.md): if the property is not defined
- [`yii\base\InvalidCallException`](/docs/api/yii/base/invalidcallexception/index.md): if the property is write-only.

### __isset() <span id="method-__isset"></span>

```php
public function __isset(mixed $name): bool
```

Checks if a property is set, i.e. defined and not null.

This method will check in the following order and act accordingly:

 - a property defined by a setter: return whether the property is set
 - a property of a behavior: return whether the property is set
 - return `false` for non existing properties

Do not call this method directly as it is a PHP magic method that
will be implicitly called when executing `isset($component->property)`.

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$name` | `mixed` | The property name or the event name |

**Returns**

`bool`: Whether the named property is set

### __set() <span id="method-__set"></span>

```php
public function __set(mixed $name, mixed $value): mixed
```

Sets the value of a component property.

This method will check in the following order and act accordingly:

 - a property defined by a setter: set the property value
 - an event in the format of "on xyz": attach the handler to the event "xyz"
 - a behavior in the format of "as xyz": attach the behavior named as "xyz"
 - a property of a behavior: set the behavior property value

Do not call this method directly as it is a PHP magic method that
will be implicitly called when executing `$component->property = $value;`.

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$name` | `mixed` | The property name or the event name |
| `$value` | `mixed` | The property value |

**Returns**

`mixed`

**Throws**

- [`yii\base\UnknownPropertyException`](/docs/api/yii/base/unknownpropertyexception/index.md): if the property is not defined
- [`yii\base\InvalidCallException`](/docs/api/yii/base/invalidcallexception/index.md): if the property is read-only.

### __unset() <span id="method-__unset"></span>

```php
public function __unset(mixed $name): mixed
```

Sets a component property to be null.

This method will check in the following order and act accordingly:

 - a property defined by a setter: set the property value to be null
 - a property of a behavior: set the property value to be null

Do not call this method directly as it is a PHP magic method that
will be implicitly called when executing `unset($component->property)`.

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$name` | `mixed` | The property name |

**Returns**

`mixed`

**Throws**

- [`yii\base\InvalidCallException`](/docs/api/yii/base/invalidcallexception/index.md): if the property is read only.

### attributeLabels() <span id="method-attributeLabels"></span>

```php
public function attributeLabels(): array<string, string>
```

Returns the attribute labels.

Attribute labels are mainly used for display purpose. For example, given an attribute
`firstName`, we can declare a label `First Name` which is more user-friendly and can
be displayed to end users.

By default an attribute label is generated using [`generateAttributeLabel()`](/docs/api/yii/base/model/index.md#method-generateAttributeLabel).
This method allows you to explicitly specify attribute labels.

Note, in order to inherit labels defined in the parent class, a child class needs to
merge the parent labels with child labels using functions such as `array_merge()`.

**Returns**

`array<string, string>`: Attribute labels (name => label)

### attributes() <span id="method-attributes"></span>

```php
public function attributes(): string[]
```

Returns the list of attribute names.

By default, this method returns all public non-static properties of the class.
You may override this method to change the default behavior.

**Returns**

`string[]`: List of attribute names.

### build() <span id="method-build"></span>

```php
public function build(bool $runValidation = true): mixed|false
```

Builds actual filter specification form [`$filter`](/docs/api/yii/data/datafilter/index.md#property-filter) value.

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$runValidation` | `bool` | Whether to perform validation (calling [`validate()`](/docs/api/yii/base/model/index.md#method-validate)) before building the filter. Defaults to `true`. If the validation fails, no filter will be built and this method will return `false`. |

**Returns**

`mixed|false`: Built actual filter value, or `false` if validation fails.

### canGetProperty() <span id="method-canGetProperty"></span>

```php
public function canGetProperty(mixed $name, mixed $checkVars = true, mixed $checkBehaviors = true): bool
```

Returns a value indicating whether a property can be read.

A property can be read if:

- the class has a getter method associated with the specified name
  (in this case, property name is case-insensitive);
- the class has a member variable with the specified name (when `$checkVars` is true);
- an attached behavior has a readable property of the given name (when `$checkBehaviors` is true).

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$name` | `mixed` | The property name |
| `$checkVars` | `mixed` | Whether to treat member variables as properties |
| `$checkBehaviors` | `mixed` | Whether to treat behaviors' properties as properties of this component |

**Returns**

`bool`: Whether the property can be read

### canSetProperty() <span id="method-canSetProperty"></span>

```php
public function canSetProperty(mixed $name, mixed $checkVars = true, mixed $checkBehaviors = true): bool
```

Returns a value indicating whether a property can be set.

A property can be written if:

- the class has a setter method associated with the specified name
  (in this case, property name is case-insensitive);
- the class has a member variable with the specified name (when `$checkVars` is true);
- an attached behavior has a writable property of the given name (when `$checkBehaviors` is true).

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$name` | `mixed` | The property name |
| `$checkVars` | `mixed` | Whether to treat member variables as properties |
| `$checkBehaviors` | `mixed` | Whether to treat behaviors' properties as properties of this component |

**Returns**

`bool`: Whether the property can be written

### formName() <span id="method-formName"></span>

```php
public function formName(): string
```

Returns the form name that this model class should use.

The form name is mainly used by [`ActiveForm`](/docs/api/yii/widgets/activeform/index.md) to determine how to name
the input fields for the attributes in a model. If the form name is "A" and an attribute
name is "b", then the corresponding input name would be "A[b]". If the form name is
an empty string, then the input name would be "b".

The purpose of the above naming schema is that for forms which contain multiple different models,
the attributes of each model are grouped in sub-arrays of the POST-data and it is easier to
differentiate between them.

By default, this method returns the model class name (without the namespace part)
as the form name. You may override it when the model is used in different forms.

**Returns**

`string`: The form name of this model class.

**Throws**

- [`yii\base\InvalidConfigException`](/docs/api/yii/base/invalidconfigexception/index.md): when form is defined with anonymous class and `formName()` method is not overridden.

### getErrorMessages() <span id="method-getErrorMessages"></span>

```php
public function getErrorMessages(): array
```

**Returns**

`array`: Error messages in format `[errorKey => message]`.

### getFilter() <span id="method-getFilter"></span>

```php
public function getFilter(): mixed
```

**Returns**

`mixed`: Raw filter value.

### getSearchAttributeTypes() <span id="method-getSearchAttributeTypes"></span>

```php
public function getSearchAttributeTypes(): array
```

**Returns**

`array`: Search attribute type map.

### getSearchModel() <span id="method-getSearchModel"></span>

```php
public function getSearchModel(): yii\base\Model
```

**Returns**

[`yii\base\Model`](/docs/api/yii/base/model/index.md): Model instance.

**Throws**

- [`yii\base\InvalidConfigException`](/docs/api/yii/base/invalidconfigexception/index.md): on invalid configuration.

### normalize() <span id="method-normalize"></span>

```php
public function normalize(bool $runValidation = true): array|bool
```

Normalizes filter value, replacing raw keys according to [`$filterControls`](/docs/api/yii/data/datafilter/index.md#property-filterControls) and [`$attributeMap`](/docs/api/yii/data/datafilter/index.md#property-attributeMap).

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$runValidation` | `bool` | Whether to perform validation (calling [`validate()`](/docs/api/yii/base/model/index.md#method-validate)) before normalizing the filter. Defaults to `true`. If the validation fails, no filter will be processed and this method will return `false`. |

**Returns**

`array|bool`: Normalized filter value, or `false` if validation fails.

### rules() <span id="method-rules"></span>

```php
public function rules(): array<int, array<array-key, mixed>|yii\validators\Validator>
```

Returns the validation rules for attributes.

Validation rules are used by [`validate()`](/docs/api/yii/base/model/index.md#method-validate) to check if attribute values are valid.
Child classes may override this method to declare different validation rules.

Each rule is an array with the following structure:

```
[
    ['attribute1', 'attribute2'],
    'validator type',
    'on' => ['scenario1', 'scenario2'],
    //...other parameters...
]
```

where

 - attribute list: required, specifies the attributes array to be validated, for single attribute you can pass a string;
 - validator type: required, specifies the validator to be used. It can be a built-in validator name,
   a method name of the model class, an anonymous function, or a validator class name.
 - on: optional, specifies the [scenarios](/docs/api/yii/base/model/index.md#property-scenario) array in which the validation
   rule can be applied. If this option is not set, the rule will apply to all scenarios.
 - additional name-value pairs can be specified to initialize the corresponding validator properties.
   Please refer to individual validator class API for possible properties.

A validator can be either an object of a class extending [`Validator`](/docs/api/yii/validators/validator/index.md), or a model class method
(called *inline validator*) that has the following signature:

```
// $params refers to validation parameters given in the rule
function validatorName($attribute, $params)
```

In the above `$attribute` refers to the attribute currently being validated while `$params` contains an array of
validator configuration options such as `max` in case of `string` validator. The value of the attribute currently being validated
can be accessed as `$this->$attribute`. Note the `$` before `attribute`; this is taking the value of the variable
`$attribute` and using it as the name of the property to access.

Yii also provides a set of [built-in validators](/docs/api/yii/validators/validator/index.md#property-builtInValidators).
Each one has an alias name which can be used when specifying a validation rule.

Below are some examples:

```
[
    // built-in "required" validator
    [['username', 'password'], 'required'],
    // built-in "string" validator customized with "min" and "max" properties
    ['username', 'string', 'min' => 3, 'max' => 12],
    // built-in "compare" validator that is used in "register" scenario only
    ['password', 'compare', 'compareAttribute' => 'password2', 'on' => 'register'],
    // an inline validator defined via the "authenticate()" method in the model class
    ['password', 'authenticate', 'on' => 'login'],
    // a validator of class "DateRangeValidator"
    ['dateRange', 'DateRangeValidator'],
];
```

Note, in order to inherit rules defined in the parent class, a child class needs to
merge the parent rules with child rules using functions such as `array_merge()`.

**Returns**

`array<int, array<array-key, mixed>|`[`yii\validators\Validator`](/docs/api/yii/validators/validator/index.md)`>`: Validation rules

### setErrorMessages() <span id="method-setErrorMessages"></span>

```php
public function setErrorMessages(array|Closure $errorMessages): mixed
```

Sets the list of error messages responding to invalid filter structure, in format: `[errorKey => message]`.

Message may contain placeholders that will be populated depending on the message context.
For each message a `{filter}` placeholder is available referring to the label for [`$filterAttributeName`](/docs/api/yii/data/datafilter/index.md#property-filterAttributeName) attribute.

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$errorMessages` | `array\|`[`Closure`](https://www.php.net/manual/en/class.closure.php) | Error messages in `[errorKey => message]` format, or a PHP callback returning them. |

**Returns**

`mixed`

### setFilter() <span id="method-setFilter"></span>

```php
public function setFilter(mixed $filter): mixed
```

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$filter` | `mixed` | Raw filter value. |

**Returns**

`mixed`

### setSearchAttributeTypes() <span id="method-setSearchAttributeTypes"></span>

```php
public function setSearchAttributeTypes(array|null $searchAttributeTypes): mixed
```

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$searchAttributeTypes` | `array\|null` | Search attribute type map. |

**Returns**

`mixed`

### setSearchModel() <span id="method-setSearchModel"></span>

```php
public function setSearchModel(yii\base\Model|array|string|callable $model): mixed
```

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$model` | [`yii\base\Model`](/docs/api/yii/base/model/index.md)`\|array\|string\|callable` | Model instance or its DI compatible configuration. |

**Returns**

`mixed`

**Throws**

- [`yii\base\InvalidConfigException`](/docs/api/yii/base/invalidconfigexception/index.md): on invalid configuration.

### validateFilter() <span id="method-validateFilter"></span>

```php
public function validateFilter(): mixed
```

Validates filter attribute value to match filer condition specification.

**Returns**

`mixed`

### buildInternal() <span id="method-buildInternal"></span>

```php
protected function buildInternal(): mixed
```

Performs actual filter build.

By default this method returns result of [`normalize()`](/docs/api/yii/data/datafilter/index.md#method-normalize).
The child class may override this method providing more specific implementation.

**Returns**

`mixed`: Built actual filter value.

### defaultErrorMessages() <span id="method-defaultErrorMessages"></span>

```php
protected function defaultErrorMessages(): array
```

Returns default values for [`$errorMessages`](/docs/api/yii/data/datafilter/index.md#property-errorMessages).

**Returns**

`array`: Default error messages in `[errorKey => message]` format.

### detectSearchAttributeType() <span id="method-detectSearchAttributeType"></span>

```php
protected function detectSearchAttributeType(yii\validators\Validator $validator): string|null
```

Detect attribute type from given validator.

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$validator` | [`yii\validators\Validator`](/docs/api/yii/validators/validator/index.md) | Validator from which to detect attribute type. |

**Returns**

`string|null`: Detected attribute type.

**Since**

2.0.14

### detectSearchAttributeTypes() <span id="method-detectSearchAttributeTypes"></span>

```php
protected function detectSearchAttributeTypes(): array
```

Composes default value for [`$searchAttributeTypes`](/docs/api/yii/data/datafilter/index.md#property-searchAttributeTypes) from the [`$searchModel`](/docs/api/yii/data/datafilter/index.md#property-searchModel) validation rules.

**Returns**

`array`: Attribute type map.

### filterAttributeValue() <span id="method-filterAttributeValue"></span>

```php
protected function filterAttributeValue(string $attribute, mixed $value): mixed
```

Validates attribute value in the scope of [`$searchModel`](/docs/api/yii/data/datafilter/index.md#property-searchModel), applying attribute value filters if any.

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$attribute` | `string` | Attribute name. |
| `$value` | `mixed` | Attribute value. |

**Returns**

`mixed`: Filtered attribute value.

### parseErrorMessage() <span id="method-parseErrorMessage"></span>

```php
protected function parseErrorMessage(string $messageKey, array $params = []): string
```

Parses content of the message from [`$errorMessages`](/docs/api/yii/data/datafilter/index.md#property-errorMessages), specified by message key.

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$messageKey` | `string` | Message key. |
| `$params` | `array` | Params to be parsed into the message. |

**Returns**

`string`: Composed message string.

### validateAttributeCondition() <span id="method-validateAttributeCondition"></span>

```php
protected function validateAttributeCondition(string $attribute, mixed $condition): mixed
```

Validates search condition for a particular attribute.

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$attribute` | `string` | Search attribute name. |
| `$condition` | `mixed` | Search condition. |

**Returns**

`mixed`

### validateAttributeValue() <span id="method-validateAttributeValue"></span>

```php
protected function validateAttributeValue(string $attribute, mixed $value): mixed
```

Validates attribute value in the scope of [`Model`](/docs/api/yii/base/model/index.md).

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$attribute` | `string` | Attribute name. |
| `$value` | `mixed` | Attribute value. |

**Returns**

`mixed`

### validateBlockCondition() <span id="method-validateBlockCondition"></span>

```php
protected function validateBlockCondition(string $operator, mixed $condition): mixed
```

Validates block condition that consists of a single condition.

This covers such operators as `not`.

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$operator` | `string` | Raw operator control keyword. |
| `$condition` | `mixed` | Raw condition. |

**Returns**

`mixed`

### validateCondition() <span id="method-validateCondition"></span>

```php
protected function validateCondition(mixed $condition): mixed
```

Validates filter condition.

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$condition` | `mixed` | Raw filter condition. |

**Returns**

`mixed`

### validateConjunctionCondition() <span id="method-validateConjunctionCondition"></span>

```php
protected function validateConjunctionCondition(string $operator, mixed $condition): mixed
```

Validates conjunction condition that consists of multiple independent ones.

This covers such operators as `and` and `or`.

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$operator` | `string` | Raw operator control keyword. |
| `$condition` | `mixed` | Raw condition. |

**Returns**

`mixed`

### validateOperatorCondition() <span id="method-validateOperatorCondition"></span>

```php
protected function validateOperatorCondition(string $operator, mixed $condition, string|null $attribute = null): mixed
```

Validates operator condition.

**Parameters**

| Parameter | Type | Description |
| --- | --- | --- |
| `$operator` | `string` | Raw operator control keyword. |
| `$condition` | `mixed` | Attribute condition. |
| `$attribute` | `string\|null` | Attribute name. |

**Returns**

`mixed`